      PROGRAM MODPLOT
C-----------------------------------------------------------------------
C PROGRAMME ECRIT PAR GRAZYNA STASINSKA  (grazyna.stasinska@obspm.fr)
C 
C LECTURE DE GRILLES DE MODELES DE REGIONS HII OBTENUS AVEC LE CODE PHOTO
C ET PLOT DE SERIES DE MODELES A l'AIDE DU LOGICIEL PGPLOT

C-----------------------------------------------------------------------
      PARAMETER (IMODDIM=60)
      PARAMETER (IRDIM=100)
      PARAMETER (IFILDIM=60)
      PARAMETER (ILIDIM=19)
      PARAMETER (ICODIM=13)

      CHARACTER*8 NOMOD(IFILDIM,IMODDIM)
      CHARACTER*3 NTMOY(ICODIM)
      CHARACTER*11 WLENGTH(ILIDIM,ICODIM)
      CHARACTER*11 WCSLENGTH(ILIDIM,ICODIM)
      CHARACTER*11 WCNLENGTH(ILIDIM,ICODIM)

      INTEGER*4 ISERI(IFILDIM,IMODDIM)
      INTEGER*4 KPAS(IFILDIM,IMODDIM)
      INTEGER*4 IMODF(IFILDIM,IMODDIM)
      INTEGER*4 ISOUSERI(IFILDIM,IMODDIM)
      INTEGER*4 ISYMB(60)

      REAL*4 PAR(IFILDIM,IMODDIM,ILIDIM,ICODIM)
      REAL*4 FLAMBDA(IFILDIM,IMODDIM,ILIDIM,ICODIM)
      REAL*4 FCSLAMBDA(IFILDIM,IMODDIM,ILIDIM,ICODIM)
      REAL*4 FCNLAMBDA(IFILDIM,IMODDIM,ILIDIM,ICODIM)
      REAL*4 XMOY(IFILDIM,IMODDIM,ILIDIM,ICODIM)
      REAL*4 TMOY(IFILDIM,IMODDIM,ICODIM)

      INTEGER*4 NMOD(IFILDIM)
      INTEGER*4 IRS(IRDIM)
      INTEGER*4 NUCLAS(IFILDIM,IMODDIM)

      REAL*4 SSIZE(IFILDIM,IMODDIM)
      REAL*4 XPLOT(IFILDIM,IMODDIM),YPLOT(IFILDIM,IMODDIM)
      REAL*4 ZPLOT(IFILDIM,IMODDIM)
      REAL*4 XG(IMODDIM),YG(IMODDIM)
      

      CHARACTER*1 FIGLABEL,TEX1A
      CHARACTER*1 LBOXX,LBOXY
      CHARACTER*7 BOXX,BOXY
      CHARACTER*2 TEX2A,TEX2B
      CHARACTER*3 TEX3A
      CHARACTER*4 NUMI
      CHARACTER*40 TEX40A
      CHARACTER*80 LIGNE
      CHARACTER*80 XLBL,YLBL
      CHARACTER*130 TOPLBL
      INTEGER*4 ITIME3(3),IDATE3(3)
      CHARACTER*8 TEX8A
      CHARACTER*9 TEX9A
      CHARACTER*8 FILETAB(IFILDIM)
      CHARACTER*7 FILETAB7(IFILDIM)
      CHARACTER*5 SERIMODEL
      CHARACTER*80 DEVICE
      CHARACTER*30 DEVICP
      CHARACTER*5 DEVICN
      CHARACTER*18 TEXDATETIME

C-----------------------------------------------------------------------
C QUELQUES CONSTANTES UTILES
      REAL*4 PI
      REAL*4 PARSEC,SECRAD,GGRAVI
      REAL*4 SOLLUM,SOLMAS,SOLRAD
      REAL*4 PROMAS,ELVOLT,CLIGHT
      REAL*4 PLANCK,BOLTZK,STEFAN
      REAL*4 YEAR
      DATA PI/3.141592654/  
      DATA PARSEC,SECRAD,GGRAVI/3.0857E18,2.0627E5,6.670E-8/
      DATA SOLLUM,SOLMAS,SOLRAD/3.826E33,1.989E33,6.9599E10/
      DATA PROMAS,ELVOLT,CLIGHT/1.66053E-24,1.602192E-12,2.997925E10/
      DATA PLANCK,BOLTZK,STEFAN/6.6262E-27,1.3806E-16,5.66956E-5/
      DATA YEAR/3.1536E+7/
C-----------------------------------------------------------------------

C UNIX
d      EXTERNAL IDATE,ITIME
d      CALL IDATE(IDATE3)
d      CALL ITIME(ITIME3)
d      IDATE3(3)=MOD(IDATE3(3),100)  ! POUR AVOIR L'ANNEE AVEC DEUX CHIFFRES
d      WRITE(6,1)
d    1 FORMAT(1X,45X,'******************************')
d      WRITE(6,900)IDATE3,ITIME3
d  900 FORMAT (1X,45X,'*',4X,I2,'-',I3,'-',I2,3X,I2,':',I2,':',I2,4x,'*')
d      WRITE(6,3)
d    3 FORMAT(1X,45X,'******************************')

C-----------------------------------------------------------------------
C FORMATTAGE DES PLOTS
C-----------------------------------------------------------------------

      WRITE(*,*)' E OU PS OU VPS'
      READ(5,'(A)')DEVICP
      WRITE(*,*)' QUALIFICATIF DU PLOT HM? (5 caracteres)'
      READ(5,'(A)')DEVICN
      IF (DEVICP.EQ.'E') THEN
      DEVICE='/XTERM'
      ELSE
      DEVICE='HM_'//DEVICN//'.PS/'//DEVICP
      ENDIF
      WRITE(*,*)DEVICE
      WRITE(*,*) 'ITOPLBL?'
      READ(5,*)ITOPLBL
      WRITE(*,*)' TOPLBL=',ITOPLBL
      WRITE(*,*) 'NSUBPLOTX,NSUBPLOTY?'
      READ(5,*)NSUBPLOTX,NSUBPLOTY
      WRITE(*,*)NSUBPLOTX,NSUBPLOTY

      WRITE(*,*)'ENTRER 1 POUR SYMBOLES+LABELS, 0 POUR SYMBOLES SEULS'
      READ(5,*)ILABEL
      WRITE(*,*)'TAILLE DES SYMBOLES (1. EST LA TAILLE STANDARD)'
      READ(5,*)SSYMB
D      WRITE(*,*)'NUMERO DU SYMBOLE'
D      WRITE(*,*)' BLANC:'
D      WRITE(*,*)'6:CARRE; 4:ROND; 7:TRIANGLE; 11:LOSANGE; 2:PLUS; 3:*'
D      WRITE(*,*)'5:MULTIPLIE; 12:ETOILE; 8:PLUS DANS ROND; 9: SOLEIL'
D      WRITE(*,*)'10: CARRE "INCURVE"; 14: CROIX GRECQUE'
D      WRITE(*,*)'15: ETOILE DE DAVID'
D      WRITE(*,*)' NOIR'
D      WRITE(*,*)' 13: TRIANGLE; 16:CARRE; 17:ROND; 18:ETOILE' 
D      READ(5,*)KSYMB
      KSYMB=4

      DATA (ISYMB(I),I=1,60)/4,6,7,11,2,3,5,12,10,
     & 9,8,14,15,13,16,17,18,18,18,18,
     & 18,18,18,18,18,18,18,18,18,18,
     & 18,18,18,18,18,18,18,18,18,18,
     & 18,18,18,18,18,18,18,18,18,18,
     & 18,18,18,18,18,18,18,18,18,18/


      IF (NFILE.GT.60) THEN
      WRITE(6,*)'NFILE > DIMENSION DE ISYMB STOP'
      CALL EXIT
      ENDIF

      CALL PGBEGIN(0,DEVICE,NSUBPLOTX,NSUBPLOTY)

      ECHELLE=0.9                
      EXMIN=.16*ECHELLE
      EXMAX=.96*ECHELLE
      EYMIN=.18*ECHELLE  
      EYMAX=.98*ECHELLE  

      WRITE(*,*) 'NB DE PLOTS (IRSM)?'
      ACCEPT *,IRSM
      WRITE(*,*)' NUMEROS DES PLOTS (IRS(I),I=1,IRSM)?'
      ACCEPT *,(IRS(I),I=1,IRSM)

      IF (IR.GT.IRDIM) THEN
      WRITE(6,*) 'IR',IR, '>IRDIM ',IRDIM, ' STOP'
      CALL EXIT
      ENDIF

C-----------------------------------------------------------------------
C FIN DE FORMATTAGE DES PLOTS
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
C LECTURE DES FICHIERS
C-----------------------------------------------------------------------

      WRITE(*,*)' NB DE SERIES DE PLOTS?'
      ACCEPT *,NSERIDIAG
      DO ISERIDIAG=1,NSERIDIAG

      WRITE(*,*)'quelle serie de modeles? (SCH96 SL96 SS99 KU92 SC99) ?'
      READ(5,'(A)')SERIMODEL
      WRITE(*,'(A)')SERIMODEL


C INITIALISATION POUR L'IMPRESSION SUR LE GRAPHE DES 6 PREMIERES NOMS
      DO IFILE=1,6
      FILETAB(IFILE)='        '
      END DO

      WRITE(*,*)'NOMBRE DE FICHIERS A LIRE ?'
      READ(5,*)NFILE

      IF (NFILE.GT.IFILDIM) THEN
      WRITE(6,*),'NFILE=',NFILE,' > IFILDIM',IFILDIM,' STOP'
      CALL EXIT
      ENDIF

      DO IFILE=1,NFILE
      WRITE(*,*)'IFILE=',IFILE,'NOM DU FICHIER A LIRE ?'
      READ(5,'(A)')FILETAB(IFILE)

      IF (SERIMODEL.EQ.'SS99') THEN
      OPEN (UNIT=52,
     & FILE='SS99_'//FILETAB(IFILE)//
     & '.RES',STATUS='OLD',READONLY,SHARED)
      ENDIF


      READ(52,*)
      READ(52,*)

      IMOD=0
 5001 CONTINUE
      IMOD=IMOD+1

      IF (IMOD.GT.IMODDIM) THEN
      WRITE(6,*),'IMOD=',IMOD,' > IMODDIM',IMODDIM,' STOP'
      CALL EXIT
      ENDIF

      READ(52,*,ERR=5002,END=5000)
      READ(52,5200,ERR=5002,END=5000)NOMOD(IFILE,IMOD),
     & ISERI(IFILE,IMOD),KPAS(IFILE,IMOD),IMODF(IFILE,IMOD)
 5200 FORMAT(9X,A8,13X,I4,13X,I4,13X,I4)

D      PRINT 5100,NOMOD(IFILE,IMOD),
D     & ISERI(IFILE,IMOD),KPAS(IFILE,IMOD),IMODF(IFILE,IMOD)
D 5100 FORMAT(1X,9X,A8,13X,I4,13X,I4,13X,I4)

      IF (IMOD.EQ.1) THEN
      ISOUSERI(IFILE,IMOD)=1
      ELSE
      IF (ISERI(IFILE,IMOD).EQ.(ISERI(IFILE,IMOD-1))) THEN
      ISOUSERI(IFILE,IMOD)=ISOUSERI(IFILE,IMOD-1)+1
      ELSE
      ISOUSERI(IFILE,IMOD)=1
      ENDIF
      ENDIF
      WRITE(6,5004) FILETAB(IFILE),ISERI(IFILE,IMOD),
     & ISOUSERI(IFILE,IMOD),IMOD,IMODF(IFILE,IMOD)
 5004 FORMAT (1X,A8,' ISERI',I5,' ISOUSERI',I5,' IMOD',I5,'IMODF',I5)

      DO ILI=1,9
      READ(52,5201,ERR=5002,END=5000)(PAR(IFILE,IMOD,ILI,ICO),ICO=1,7)
 5201 FORMAT(7(7X,E10.3))
D      PRINT 5101 (PAR(IFILE,IMOD,ILI,ICO),ICO=1,7)
D 5101 FORMAT(1X,7(7X,1P,E10.3))
      END DO

      READ(52,*)
      DO ILI=1,2
      READ(52,5202,ERR=5002,END=5000)(WCSLENGTH(ILI,ICO),
     & FCSLAMBDA(IFILE,IMOD,ILI,ICO),ICO=1,6)
      END DO

      READ(52,*)
      DO ILI=1,2
      READ(52,5202,ERR=5002,END=5000)(WCNLENGTH(ILI,ICO),
     & FCNLAMBDA(IFILE,IMOD,ILI,ICO),ICO=1,6)
      END DO

      READ(52,*)
C LA PREMIERE LIGNE EST LUE SEPAREMENT CAR ON NE LIT PAS HBETA EN ERG/S,
C QUI PEUT ETRE PLUS GRAND QUE LA PLUS GRANDE VALEUR ADMISE PAR L'ORDINATEUR
      DO ILI=1,1
      READ(52,5292,ERR=5002,END=5000)(WLENGTH(ILI,ICO),
     & FLAMBDA(IFILE,IMOD,ILI,ICO),ICO=2,6)
 5292 FORMAT((1X,11X,1X,9X),5(1X,A11,1X,E9.2))
      END DO
      DO ILI=2,19
      READ(52,5202,ERR=5002,END=5000)(WLENGTH(ILI,ICO),
     & FLAMBDA(IFILE,IMOD,ILI,ICO),ICO=1,6)
 5202 FORMAT(6(1X,A11,1X,E9.2))
D      PRINT 5102,(WLENGTH(ILI,ICO),
D     & FLAMBDA(IFILE,IMOD,ILI,ICO),ICO=1,6)
D 5102 FORMAT(1X,6(1X,A11,1X,1P,E9.2))
      END DO

      READ(52,*)
      DO ILI=1,11 !GHR
      READ(52,5203,ERR=5002,END=5000)(XMOY(IFILE,IMOD,ILI,ICO),
     & ICO=1,10) 
 5203 FORMAT(6X,10(3X,E9.2))
D      PRINT 5103,(XMOY(IFILE,IMOD,ILI,ICO),ICO=1,10)
D 5103 FORMAT(1X,6X,10(3X,1P,E9.2))
      END DO

      READ(52,*)
      READ(52,5204,ERR=5002,END=5000)(NTMOY(ICO),
     & TMOY(IFILE,IMOD,ICO),ICO=1,13)
 5204 FORMAT(2X,13(A3,F7.0))
D      PRINT 5104,(NTMOY(ICO),
D     & TMOY(IFILE,IMOD,ICO),ICO=1,13)
D 5104 FORMAT(1X,2X,13(A3,F7.0))


      GO TO 5001

 5002 CONTINUE
      WRITE(6,*) 'ERREUR DANS ',FILETAB(IFILE),' IMOD',IMOD,'ILI=',ILI
      CALL EXIT

 5000 CONTINUE

      NMOD(IFILE)=IMOD-1
      WRITE(6,*) 'IFILE',IFILE,FILETAB(IFILE),' NMOD=',NMOD(IFILE)
      CLOSE (52)
      END DO
      WRITE(6,*)'FIN DES LECTURES'

C-----------------------------------------------------------------------
C FIN DES LECTURES
C-----------------------------------------------------------------------


      IRSS=0
 3000 CONTINUE
      IRSS=IRSS+1
      IF (IRSS.GT.IRSM) GO TO 3001
      IR=IRS(IRSS)

C INITIALISATION DES SYMBOLES
      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      SSIZE(IFILE,IMOD)=SSYMB
      END DO 
      END DO

      CALL PGADVANCE

      CALL PGVPORT(EXMIN,EXMAX,EYMIN,EYMAX)

      IF (IR.EQ.1) THEN
      XLBL='[OII] 3727 / H\\gb'
      YLBL='[OIII] 5007 / H\\gb '
      LBOXX='L'
      LBOXY='L'
      XMIN=-2.
      XMAX=2.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=FLAMBDA(IFILE,IMOD,6,5)      
      YVA=FLAMBDA(IFILE,IMOD,7,4)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.2) THEN
      XLBL='[NII] 6583 / H\\gb'
      YLBL='[OIII] 5007 / H\\gb '
      LBOXX='L'
      LBOXY='L'
      XMIN=-2.
      XMAX=2.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=FLAMBDA(IFILE,IMOD,4,4)
      YVA=FLAMBDA(IFILE,IMOD,7,4)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.3) THEN
      XLBL='[SII] 6717+6731 / H\\gb'
      YLBL='[OIII] 5007 / H\\gb '
      LBOXX='L'
      LBOXY='L'
      XMIN=-3.
      XMAX=1.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=(FLAMBDA(IFILE,IMOD,13,2)+FLAMBDA(IFILE,IMOD,13,3))
      YVA=FLAMBDA(IFILE,IMOD,7,4)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.4) THEN
      XLBL='[OI] 6300 / H\\gb'
      YLBL='[OIII] 5007 / H\\gb '
      LBOXX='L'
      LBOXY='L'
      XMIN=-4.
      XMAX=0.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=FLAMBDA(IFILE,IMOD,6,2)
      YVA=FLAMBDA(IFILE,IMOD,7,4)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.5) THEN
      XLBL='EW(H\\gb) (A)'
      YLBL='([OII]3727 +[OIII]5007) / H\\gb'
      LBOXX='L'
      LBOXY='L'
      XMIN=0.
      XMAX=3.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=FLAMBDA(IFILE,IMOD,6,5)+FLAMBDA(IFILE,IMOD,7,4)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.6) THEN
      XLBL='EW(H\\gb) (A)'
      YLBL='[OIII] 5007 / [OII] 3727'
      LBOXX='L'
      LBOXY='L'
      XMIN=0.
      XMAX=3.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=FLAMBDA(IFILE,IMOD,7,4)/FLAMBDA(IFILE,IMOD,6,5)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.7) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='[OIII] 5007 / H\\gb '
      LBOXX='L'
      LBOXY='L'
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=FLAMBDA(IFILE,IMOD,7,4)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.8) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='He I 5876 / H\\gb '
      LBOXX='L'
      LBOXY='L'
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=-4.
      YMAX=+0. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=FLAMBDA(IFILE,IMOD,1,4)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.9) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='He II 4686 / H\\gb '
      LBOXX='L'
      LBOXY='L'
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=-4.
      YMAX=+0. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=FLAMBDA(IFILE,IMOD,1,6)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.10) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='[OII] 3727 / H\\gb'
      LBOXX='L'
      LBOXY='L'
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=FLAMBDA(IFILE,IMOD,6,5)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.11) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='[OI] 6300 / H\\gb '
      LBOXX='L'
      LBOXY='L'
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=-4.
      YMAX=+0. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=FLAMBDA(IFILE,IMOD,6,2)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.12) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='[OIII] 4363 / [OIII] 5007 '
      LBOXX='L'
      LBOXY='L'
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=-4.
      YMAX=+0. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      IF (FLAMBDA(IFILE,IMOD,7,4).NE.0.)
     & YVA=FLAMBDA(IFILE,IMOD,7,3)/FLAMBDA(IFILE,IMOD,7,4)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.13) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='U'
      LBOXX='L'
      LBOXY='L'
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=-5.
      YMAX=+0. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=PAR(IFILE,IMOD,6,6)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.14) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='QHE0/QH0 '
      LBOXX='L'
      LBOXY='L'
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=-4.
      YMAX=+0. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=PAR(IFILE,IMOD,6,3)/PAR(IFILE,IMOD,6,2)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.15) THEN
      YLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      LBOXX='L'
      LBOXY='L'
      YMIN=1.
      YMAX=10.
      XMIN=0.
      XMAX=3.

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      YVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.16) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='T(O\\u++\\d) '
      LBOXX='L'
      LBOXY=' '
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=0.
      YMAX=25000.

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=TMOY(IFILE,IMOD,11)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=YVA
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.17) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='T(O\\u+\\d) '
      LBOXX='L'
      LBOXY=' '
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=0.
      YMAX=25000. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=TMOY(IFILE,IMOD,10)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=YVA
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.18) THEN
D      XLBL='L(H\\gb) (SOLAR UNITS)'
      XLBL='EW(H\\gb) (A)'
      YLBL='x(O\\u++\\d) / x(H\\u+\\d)'
      LBOXX='L'
      LBOXY=' '
D      XMIN=4.5
D      XMAX=7.5
      XMIN=0.
      XMAX=3.
      YMIN=0.
      YMAX=+1.1 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
D      XVA=PAR(IFILE,IMOD,9,2)      
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=XMOY(IFILE,IMOD,4,3)/XMOY(IFILE,IMOD,1,2)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=YVA
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.19) THEN
      XLBL='[OIII] 3727 + [OIII] 5007'
      YLBL='[OIII] 5007 / [OII] 3727'
      LBOXX='L'
      LBOXY='L'
d      XMIN=-2.
d      XMAX=2.
      XMIN=-0.7
      XMAX=1.2
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=FLAMBDA(IFILE,IMOD,7,4)+FLAMBDA(IFILE,IMOD,6,5)      
      YVA=FLAMBDA(IFILE,IMOD,7,4)/FLAMBDA(IFILE,IMOD,6,5)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.20) THEN
      XLBL='EW(H\\gb) (A)'
      YLBL='[NII] 6583 / [OII] 3727'
      LBOXX='L'
      LBOXY='L'
      XMIN=0.
      XMAX=3.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=PAR(IFILE,IMOD,9,6)      
      YVA=FLAMBDA(IFILE,IMOD,4,4)/FLAMBDA(IFILE,IMOD,6,5)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.21) THEN
      XLBL='EW(H\\gb) (A)'
      YLBL='[NeIII] 3869 / [OIII] 5007'
      LBOXX='L'
      LBOXY='L'
      XMIN=0.
      XMAX=3.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=PAR(IFILE,IMOD,9,6)      
      IF (FLAMBDA(IFILE,IMOD,7,4).NE.0.)
     & YVA=FLAMBDA(IFILE,IMOD,9,3)/FLAMBDA(IFILE,IMOD,7,4)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF


      IF (IR.EQ.22) THEN
      XLBL='[NII] 6583 / [OII] 3727'
      YLBL='[OIII] 5007 / [OII] 3727'
      LBOXX='L'
      LBOXY='L'
      XMIN=-2.
      XMAX=2.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      YVA=FLAMBDA(IFILE,IMOD,7,4)/FLAMBDA(IFILE,IMOD,6,5)      
      XVA=FLAMBDA(IFILE,IMOD,4,4)/FLAMBDA(IFILE,IMOD,6,5)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.23) THEN
      YLBL='[NeIII] 3869 / [OIII] 5007'
      XLBL='[OIII] 5007 / [OII] 3727'
      LBOXX='L'
      LBOXY='L'
      XMIN=-2.
      XMAX=2.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=FLAMBDA(IFILE,IMOD,7,4)/FLAMBDA(IFILE,IMOD,6,5)      
      IF (FLAMBDA(IFILE,IMOD,7,4).NE.0.)
     & YVA=FLAMBDA(IFILE,IMOD,9,3)/FLAMBDA(IFILE,IMOD,7,4)
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF

      IF (IR.EQ.24) THEN
      XLBL='[OIII] 5007 + [OII] 3727'
      YLBL='[NII] 6683 / [OII] 3727'
      LBOXX='L'
      LBOXY='L'
      XMIN=-2.
      XMAX=2.
      YMIN=-2.
      YMAX=+2. 

      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
      DO IMOD=1,NMODTOT
      XPLOT(IFILE,IMOD)=-20.
      YPLOT(IFILE,IMOD)=-20.
      XVA=FLAMBDA(IFILE,IMOD,7,4)+FLAMBDA(IFILE,IMOD,6,5)      
      YVA=FLAMBDA(IFILE,IMOD,4,4)/FLAMBDA(IFILE,IMOD,6,5)      
      IF (XVA.GT.0.) XPLOT(IFILE,IMOD)=ALOG10(XVA)
      IF (YVA.GT.0.) YPLOT(IFILE,IMOD)=ALOG10(YVA)
      END DO 
      END DO

      ENDIF



C-----------------------------------------------------------------------
C PLOT DES POINTS
      CALL PGWINDOW(XMIN,XMAX,YMIN,YMAX)
      BOXX=LBOXX//'BCNST'
      BOXY=LBOXY//'BCNST'
      BOXX=LBOXX//'BCNSTG' ! avec grille
      BOXY=LBOXY//'BCNSTG'  ! avec grille
      CALL PGSLW(2)  
      SIZE=2.       
      CALL PGSCH(SIZE)
      CALL PGBOX(BOXX,0.0,0,BOXY,0.0,0)

      WRITE(*,*) IR
      IOUT=0
      DO IFILE=1,NFILE
      NMODTOT=NMOD(IFILE)
C REDEFINIR NMODTOT SI ON NE VEUT PLOTTER QUE LES PREMIERS MODELES D'UNE SERIE
d      NMODTOT=3
      DO IMOD=1,NMODTOT
      NUCLAS(IFILE,IMOD)=ISYMB(IFILE)
D      SSIZE(IFILE,IMOD)=FLOAT(IFILE)
      XG(IMOD)=XPLOT(IFILE,IMOD)
      YG(IMOD)=YPLOT(IFILE,IMOD)
D      PRINT *,IFILE,IMOD,XG(IMOD),YG(IMOD)

C PLOT DES POINTS CORRESPONDANT AU DERNIER PAS D'UN MODELE
D      IF (IMODF(IFILE,IMOD).NE.0) THEN

DC PLOT DES POINTS CORRESP AUPREMIER PASSAGE DANS STOKA POUR CHAQUE MODELE
D      IF (ISOUSERI(IFILE,IMOD).EQ.1) THEN

C PLOT DES POINTS CORRESP A LA SOUS-SERIE NUMERO IVA, OU A LA DERNIERE
C SERIE D'UN MODELE       (cas standard)
      IVA=3 
      IF (ISOUSERI(IFILE,IMOD).EQ.IVA
     & .OR.(IMODF(IFILE,IMOD).NE.0.AND.ISOUSERI(IFILE,IMOD).LT.IVA))
     & THEN

C PLOT UNIQUEMENT POUR UN CERTAIN MODELE DANS CHAQUE SERIE
C SI ON VEUT PLOTTER TOUS LES MODELES D'UNE SERIE, SUPPRIMER
C LES DEUX LIGNES SUIVANTES ET LE ENDIF CORRESPONDANT

d      IMODSEL=1
d      IF (IMOD.EQ.IMODSEL) THEN       !
     
D      PRINT *,IFILE,IMOD,NUCLAS(IFILE,IMOD),ISYMB(IFILE)
      IF (IMOD.GT.1) THEN
      CALL PGSLW(1)
      CALL PGSLS(1) ! FULL LINE
d      CALL PGSLS(4) ! DOTS
      CALL PGSCI(IMOD)
      CALL PGMOVE(XG(IMOD-1),YG(IMOD-1))  ! traits joignant les diverses series dans un modele
      CALL PGDRAW(XG(IMOD),YG(IMOD))      ! traits joignant les diverses series dans un modele
      CALL PGSCI(1)
      CALL PGSLS(1) ! FULL LINE
      CALL PGSLW(1)
      ENDIF

      IF (XG(IMOD).GE.XMIN.AND.YG(IMOD).GE.YMIN.
     & AND.XG(IMOD).LE.XMAX.AND.YG(IMOD).LE.YMAX) THEN

C PLOT DES SYMBOLES
      CALL PGSLW(2)
      SIZE=SSIZE(IFILE,IMOD)
      CALL PGSCH(SIZE)

      CALL PGPOINT(1,XG(IMOD),YG(IMOD),NUCLAS(IFILE,IMOD))

      CALL PGSLW(1)

      CALL PGSCH(0.7)
      CALL PGSLW(1)
      WRITE(NUMI,'(I4)')IMOD
      IF (ILABEL.EQ.1) CALL PGTEXT(XG(IMOD),YG(IMOD),NUMI)

      ELSE
C IMPRESSION DES POINTS HORS CADRE
      IOUT=IOUT+1
      WRITE(6,1000)IFILE,IMOD,XG(IMOD),YG(IMOD),XMIN,XMAX,YMIN,YMAX
 1000 FORMAT (1X,2I4,' X',1P,D9.2,' Y',E9.2,' XMIN',E9.2,
     1 ' XMAX',E9.2,' YMIN',E9.2,' YMAX' E9.2)      
      ENDIF


d      ENDIF       ! IF (IMOD.EQ.IMODSEL)   
      ENDIF


      END DO 
      END DO


      CALL PGSLW(2) 
      SIZE=1.6

d      CALL PGSCH(SIZE)
d      WRITE(TEX3A,'(I3)')IR
d      WRITE(TEX2B,'(I2)')IOUT
d      WRITE(TEXDATETIME,901)IDATE3,ITIME3
d 901  FORMAT (I2,'-',I3,'-',I2,1X,I2,':',I2,':',I2)

      IF (ITOPLBL.EQ.1) THEN
      TOPLBL=
     & TEX3A//' '//SERIMODEL//
     & FILETAB(1)//' '//FILETAB(2)
     & //' '//FILETAB(3)//' '//FILETAB(4)//' '//FILETAB(5)
      ENDIF
      IF (ITOPLBL.EQ.0) THEN
      TOPLBL=' '
      ENDIF
      SIZE=2. 
      CALL PGSCH(SIZE)
      CALL PGLABEL(XLBL,YLBL,TOPLBL)

      IF (IR.EQ.7) TEX1A='a'
      IF (IR.EQ.8) TEX1A='b'
      IF (IR.EQ.11) TEX1A='c'
      IF (IR.EQ.10) TEX1A='d'
      IF (IR.EQ.5) TEX1A='e'
      IF (IR.EQ.20) TEX1A='f'
      IF (IR.EQ.1) TEX1A='g'
      IF (IR.EQ.3) TEX1A='h'
      IF (IR.EQ.24) TEX1A='i'

      SIZE=2.6        
      CALL PGSCH(SIZE)
      CALL PGMTEXT('T',-1.4,0.17,1.0,TEX1A)
      SIZE=1.   


      GO TO 3000 
 3001 CONTINUE

      END DO ! DO ISERIDIAG

      CALL PGEND

      END

